Import latest bootstrap.sh
[m6w6/libmemcached] / bootstrap.sh
1 #!/bin/bash
2 #
3 # Copyright (C) 2012-2013 Brian Aker
4 # All rights reserved.
5 #
6 # Redistribution and use in source and binary forms, with or without
7 # modification, are permitted provided that the following conditions are
8 # met:
9 #
10 # * Redistributions of source code must retain the above copyright
11 # notice, this list of conditions and the following disclaimer.
12 #
13 # * Redistributions in binary form must reproduce the above
14 # copyright notice, this list of conditions and the following disclaimer
15 # in the documentation and/or other materials provided with the
16 # distribution.
17 #
18 # * The names of its contributors may not be used to endorse or
19 # promote products derived from this software without specific prior
20 # written permission.
21 #
22 # THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
23 # "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
24 # LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
25 # A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
26 # OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
27 # SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
28 # LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
29 # DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
30 # THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
31 # (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
32 # OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
33
34
35 # Environment Variables that will influence the build:
36 # AUTOMAKE
37 # AUTORECONF
38 # LIBTOOLIZE
39 # MAKE
40 # PREFIX
41 # TESTS_ENVIRONMENT
42 # VERBOSE
43 # WARNINGS
44 #
45
46 command_not_found_handle ()
47 {
48 warn "$@: command not found"
49
50 #if $DEBUG; then
51 echo ""
52 echo "Stack trace:"
53 local frame=0
54 while caller $frame; do
55 ((frame++));
56 done
57 echo ""
58 #fi
59
60 return 127
61 }
62
63 function error ()
64 {
65 echo "$BASH_SOURCE:$BASH_LINENO: $@" >&2
66 }
67
68 function die ()
69 {
70 echo "$BASH_SOURCE:$BASH_LINENO: $@" >&2
71 exit 1;
72 }
73
74 function warn ()
75 {
76 echo "$BASH_SOURCE:$BASH_LINENO: $@"
77 #echo "$BASH_SOURCE:$BASH_LINENO: $@" >&1
78 }
79
80 function nassert ()
81 {
82 local param_name=\$"$1"
83 local param_value=`eval "expr \"$param_name\" "`
84
85 if [ -n "$param_value" ]; then
86 echo "$bash_source:$bash_lineno: assert($param_name) had value of "$param_value"" >&2
87 exit 1
88 fi
89 }
90
91 function assert ()
92 {
93 local param_name=\$"$1"
94 local param_value=`eval "expr \"$param_name\" "`
95
96 if [ -z "$param_value" ]; then
97 echo "$bash_source:$bash_lineno: assert($param_name)" >&2
98 exit 1
99 fi
100 }
101
102 function assert_file ()
103 {
104 if [ ! -f "$1" ]; then
105 echo "$BASH_SOURCE:$BASH_LINENO: assert($1) does not exist: $2" >&2
106 exit 1;
107 fi
108 }
109
110 function assert_no_file ()
111 {
112 if [ -f "$1" ]; then
113 echo "$BASH_SOURCE:$BASH_LINENO: assert($1) file exists: $2" >&2
114 exit 1;
115 fi
116 }
117
118 function assert_no_directory ()
119 {
120 if [ -d "$1" ]; then
121 echo "$BASH_SOURCE:$BASH_LINENO: assert($1) directory exists: $2" >&2
122 exit 1;
123 fi
124 }
125
126 function assert_exec_file ()
127 {
128 if [ ! -f "$1" ]; then
129 echo "$BASH_SOURCE:$BASH_LINENO: assert($1) does not exist: $2" >&2
130 exit 1;
131 fi
132
133 if [ ! -x "$1" ]; then
134 echo "$BASH_SOURCE:$BASH_LINENO: assert($1) exists but is not executable: $2" >&2
135 exit 1;
136 fi
137 }
138
139 function command_exists ()
140 {
141 type "$1" &> /dev/null ;
142 }
143
144 function rebuild_host_os ()
145 {
146 HOST_OS="${UNAME_MACHINE_ARCH}-${VENDOR}-${VENDOR_DISTRIBUTION}-${VENDOR_RELEASE}-${UNAME_KERNEL}-${UNAME_KERNEL_RELEASE}"
147 if [ -z "$1" ]; then
148 if $VERBOSE; then
149 echo "HOST_OS=$HOST_OS"
150 fi
151 fi
152 }
153
154 # Validate the distribution name, or toss an erro
155 # values: darwin,fedora,rhel,ubuntu,debian,opensuse
156 function set_VENDOR_DISTRIBUTION ()
157 {
158 local dist=`echo "$1" | tr '[A-Z]' '[a-z]'`
159 case "$dist" in
160 darwin)
161 VENDOR_DISTRIBUTION='darwin'
162 ;;
163 fedora)
164 VENDOR_DISTRIBUTION='fedora'
165 ;;
166 rhel)
167 VENDOR_DISTRIBUTION='rhel'
168 ;;
169 debian)
170 VENDOR_DISTRIBUTION='debian'
171 ;;
172 ubuntu)
173 VENDOR_DISTRIBUTION='ubuntu'
174 ;;
175 suse)
176 VENDOR_DISTRIBUTION='opensuse'
177 ;;
178 opensuse)
179 VENDOR_DISTRIBUTION='opensuse'
180 ;;
181 *)
182 die "attempt to set an invalid VENDOR_DISTRIBUTION=$dist"
183 ;;
184 esac
185 }
186
187 # Validate a Vendor's release name/number
188 function set_VENDOR_RELEASE ()
189 {
190 local release=`echo "$1" | tr '[A-Z]' '[a-z]'`
191
192 if $DEBUG; then
193 echo "VENDOR_DISTRIBUTION:$VENDOR_DISTRIBUTION"
194 echo "VENDOR_RELEASE:$release"
195 fi
196
197 case $VENDOR_DISTRIBUTION in
198 darwin)
199 case $release in
200 10.6*)
201 VENDOR_RELEASE='snow_leopard'
202 ;;
203 10.7*)
204 VENDOR_RELEASE='mountain'
205 ;;
206 mountain)
207 VENDOR_RELEASE='mountain'
208 ;;
209 10.8.*)
210 echo "mountain_lion"
211 VENDOR_RELEASE='mountain_lion'
212 ;;
213 *)
214 echo $VENDOR_RELEASE
215 VENDOR_RELEASE='unknown'
216 ;;
217 esac
218 ;;
219 fedora)
220 VENDOR_RELEASE="$release"
221 if [[ "x$VENDOR_RELEASE" == '18' ]]; then
222 VENDOR_RELEASE='sphericalcow'
223 fi
224 ;;
225 rhel)
226 VENDOR_RELEASE="$release"
227 ;;
228 debian)
229 VENDOR_RELEASE="$release"
230 ;;
231 ubuntu)
232 VENDOR_RELEASE="$release"
233 if [[ "x$VENDOR_RELEASE" == 'x12.04' ]]; then
234 VENDOR_RELEASE="precise"
235 elif [[ "x$VENDOR_RELEASE" == 'x12.10' ]]; then
236 VENDOR_RELEASE="quantal"
237 elif [[ "x$VENDOR_RELEASE" == 'x13.04' ]]; then
238 VENDOR_RELEASE="raring"
239 fi
240 ;;
241 opensuse)
242 VENDOR_RELEASE="$release"
243 ;;
244 unknown)
245 die "attempt to set VENDOR_RELEASE without setting VENDOR_DISTRIBUTION"
246 ;;
247 *)
248 die "attempt to set with an invalid VENDOR_DISTRIBUTION=$VENDOR_DISTRIBUTION"
249 ;;
250 esac
251 }
252
253
254 # Valid values are: apple, redhat, centos, canonical, oracle, suse
255 function set_VENDOR ()
256 {
257 local vendor=`echo "$1" | tr '[A-Z]' '[a-z]'`
258
259 case $vendor in
260 apple)
261 VENDOR='apple'
262 ;;
263 redhat)
264 VENDOR='redhat'
265 ;;
266 fedora)
267 VENDOR='redhat'
268 ;;
269 redhat-release-server-*)
270 VENDOR='redhat'
271 ;;
272 enterprise-release-*)
273 VENDOR='oracle'
274 ;;
275 centos)
276 VENDOR='centos'
277 ;;
278 canonical)
279 VENDOR='canonical'
280 ;;
281 ubuntu)
282 VENDOR='canonical'
283 ;;
284 debian)
285 VENDOR='debian'
286 ;;
287 opensuse)
288 VENDOR='suse'
289 ;;
290 suse)
291 VENDOR='suse'
292 ;;
293 *)
294 die "An attempt was made to set an invalid VENDOR=$_vendor"
295 ;;
296 esac
297
298 set_VENDOR_DISTRIBUTION $2
299 set_VENDOR_RELEASE $3
300
301 # Set which vendor/versions we trust for autoreconf
302 case $VENDOR_DISTRIBUTION in
303 fedora)
304 if [[ "x$VENDOR_RELEASE" == 'x18' ]]; then
305 AUTORECONF_REBUILD_HOST=true
306 elif [[ "x$VENDOR_RELEASE" == 'xsphericalcow' ]]; then
307 AUTORECONF_REBUILD_HOST=true
308 elif [[ "x$VENDOR_RELEASE" == 'x19' ]]; then
309 AUTORECONF_REBUILD_HOST=true
310 fi
311 ;;
312 canonical)
313 if [[ "x$VENDOR_RELEASE" == 'xprecise' ]]; then
314 AUTORECONF_REBUILD_HOST=true
315 elif [[ "x$VENDOR_RELEASE" == 'xquantal' ]]; then
316 AUTORECONF_REBUILD_HOST=true
317 fi
318 ;;
319 esac
320
321 }
322
323 function determine_target_platform ()
324 {
325 UNAME_MACHINE_ARCH=`(uname -m) 2>/dev/null` || UNAME_MACHINE_ARCH=unknown
326 UNAME_KERNEL=`(uname -s) 2>/dev/null` || UNAME_SYSTEM=unknown
327 UNAME_KERNEL_RELEASE=`(uname -r) 2>/dev/null` || UNAME_KERNEL_RELEASE=unknown
328
329 if [[ -x '/usr/bin/sw_vers' ]]; then
330 local _VERSION=`/usr/bin/sw_vers -productVersion`
331 set_VENDOR 'apple' 'darwin' $_VERSION
332 elif [[ $(uname) == 'Darwin' ]]; then
333 set_VENDOR 'apple' 'darwin' 'mountain'
334 elif [[ -f '/etc/fedora-release' ]]; then
335 local fedora_version=`cat /etc/fedora-release | awk ' { print $3 } '`
336 set_VENDOR 'redhat' 'fedora' $fedora_version
337 elif [[ -f '/etc/centos-release' ]]; then
338 local centos_version=`cat /etc/centos-release | awk ' { print $7 } '`
339 set_VENDOR 'centos' 'rhel' $centos_version
340 elif [[ -f '/etc/SuSE-release' ]]; then
341 local suse_distribution=`head -1 /etc/SuSE-release | awk ' { print $1 } '`
342 local suse_version=`head -1 /etc/SuSE-release | awk ' { print $2 } '`
343 set_VENDOR 'suse' $suse_distribution $suse_version
344 elif [[ -f '/etc/redhat-release' ]]; then
345 local rhel_version=`cat /etc/redhat-release | awk ' { print $7 } '`
346 local _vendor=`rpm -qf /etc/redhat-release`
347 set_VENDOR $_vendor 'rhel' $rhel_version
348 elif [[ -f '/etc/os-release' ]]; then
349 source '/etc/os-release'
350 set_VENDOR $ID $ID $VERSION_ID
351 elif [[ -x '/usr/bin/lsb_release' ]]; then
352 local _ID=`/usr/bin/lsb_release -s -i`
353 local _VERSION=`/usr/bin/lsb_release -s -r`
354 set_VENDOR $_ID $_ID $_VERSION_ID
355 elif [[ -f '/etc/lsb-release' ]]; then
356 source '/etc/lsb-release'
357 set_VENDOR 'canonical' $DISTRIB_ID $DISTRIB_CODENAME
358 fi
359
360 rebuild_host_os
361 }
362
363 function run_configure ()
364 {
365 # We will run autoreconf if we are required
366 run_autoreconf_if_required
367
368 # We always begin at the root of our build
369 if [ ! popd ]; then
370 die "Programmer error, we entered run_configure with a stacked directory"
371 fi
372
373 if ! command_exists "$CONFIGURE"; then
374 die "$CONFIGURE does not exist"
375 fi
376
377 local BUILD_DIR="$1"
378 if [[ -n "$BUILD_DIR" ]]; then
379 rm -r -f $BUILD_DIR
380 mkdir -p $BUILD_DIR
381 safe_pushd $BUILD_DIR
382 fi
383
384 # Arguments for configure
385 local BUILD_CONFIGURE_ARG=
386
387 # If ENV DEBUG is set we enable both debug and asssert, otherwise we see if this is a VCS checkout and if so enable assert
388 # Set ENV ASSERT in order to enable assert.
389 # If we are doing a valgrind run, we always compile with assert disabled
390 if $valgrind_run; then
391 BUILD_CONFIGURE_ARG+= " CXXFLAGS=-DNDEBUG "
392 BUILD_CONFIGURE_ARG+= " CFLAGS=-DNDEBUG "
393 else
394 if $DEBUG; then
395 BUILD_CONFIGURE_ARG+=' --enable-debug --enable-assert'
396 elif [[ -n "$VCS_CHECKOUT" ]]; then
397 BUILD_CONFIGURE_ARG+=' --enable-assert'
398 fi
399 fi
400
401 if [[ -n "$CONFIGURE_ARG" ]]; then
402 BUILD_CONFIGURE_ARG+=" $CONFIGURE_ARG"
403 fi
404
405 if [[ -n "$PREFIX_ARG" ]]; then
406 BUILD_CONFIGURE_ARG+=" $PREFIX_ARG"
407 fi
408
409 ret=1;
410 # If we are executing on OSX use CLANG, otherwise only use it if we find it in the ENV
411 case $HOST_OS in
412 *-darwin-*)
413 CC=clang CXX=clang++ $top_srcdir/configure $BUILD_CONFIGURE_ARG || die "Cannot execute CC=clang CXX=clang++ configure $BUILD_CONFIGURE_ARG"
414 ret=$?
415 ;;
416 rhel-5*)
417 command_exists 'gcc44' || die "Could not locate gcc44"
418 CC=gcc44 CXX=gcc44 $top_srcdir/configure $BUILD_CONFIGURE_ARG || die "Cannot execute CC=gcc44 CXX=gcc44 configure $BUILD_CONFIGURE_ARG"
419 ret=$?
420 ;;
421 *)
422 $CONFIGURE $BUILD_CONFIGURE_ARG
423 ret=$?
424 ;;
425 esac
426
427 if [ $ret -ne 0 ]; then
428 die "Could not execute $CONFIGURE $BUILD_CONFIGURE_ARG"
429 fi
430
431 if [ ! -f 'Makefile' ]; then
432 die "Programmer error, configure was run but no Makefile existed after $CONFIGURE was run"
433 fi
434 }
435
436 function setup_gdb_command () {
437 GDB_TMPFILE=$(mktemp /tmp/gdb.XXXXXXXXXX)
438 echo 'set logging overwrite on' > $GDB_TMPFILE
439 echo 'set logging on' >> $GDB_TMPFILE
440 echo 'set environment LIBTEST_IN_GDB=1' >> $GDB_TMPFILE
441 echo 'run' >> $GDB_TMPFILE
442 echo 'thread apply all bt' >> $GDB_TMPFILE
443 echo 'quit' >> $GDB_TMPFILE
444 GDB_COMMAND="gdb -f -batch -x $GDB_TMPFILE"
445 }
446
447 function setup_valgrind_command () {
448 VALGRIND_PROGRAM=`type -p valgrind`
449 if [[ -n "$VALGRIND_PROGRAM" ]]; then
450 VALGRIND_COMMAND="$VALGRIND_PROGRAM --error-exitcode=1 --leak-check=yes --malloc-fill=A5 --free-fill=DE --xml=yes --xml-file=\"valgrind-%p.xml\""
451 fi
452 }
453
454 function save_BUILD ()
455 {
456 if [[ -n "$OLD_CONFIGURE" ]]; then
457 die "OLD_CONFIGURE($OLD_CONFIGURE) was set on push, programmer error!"
458 fi
459
460 if [[ -n "$OLD_CONFIGURE_ARG" ]]; then
461 die "OLD_CONFIGURE_ARG($OLD_CONFIGURE_ARG) was set on push, programmer error!"
462 fi
463
464 if [[ -n "$OLD_PREFIX" ]]; then
465 die "OLD_PREFIX($OLD_PREFIX) was set on push, programmer error!"
466 fi
467
468 if [[ -n "$OLD_MAKE" ]]; then
469 die "OLD_MAKE($OLD_MAKE) was set on push, programmer error!"
470 fi
471
472 if [[ -n "$OLD_TESTS_ENVIRONMENT" ]]; then
473 die "OLD_TESTS_ENVIRONMENT($OLD_TESTS_ENVIRONMENT) was set on push, programmer error!"
474 fi
475
476 if [[ -n "$CONFIGURE" ]]; then
477 OLD_CONFIGURE=$CONFIGURE
478 fi
479
480 if [[ -n "$CONFIGURE_ARG" ]]; then
481 OLD_CONFIGURE_ARG=$CONFIGURE_ARG
482 fi
483
484 if [[ -n "$MAKE" ]]; then
485 OLD_MAKE=$MAKE
486 fi
487
488 if [[ -n "$TESTS_ENVIRONMENT" ]]; then
489 OLD_TESTS_ENVIRONMENT=$TESTS_ENVIRONMENT
490 fi
491 }
492
493 function restore_BUILD ()
494 {
495 if [[ -n "$OLD_CONFIGURE" ]]; then
496 CONFIGURE=$OLD_CONFIGURE
497 fi
498
499 if [[ -n "$OLD_CONFIGURE_ARG" ]]; then
500 CONFIGURE_ARG=$OLD_CONFIGURE_ARG
501 fi
502
503 if [[ -n "$OLD_PREFIX" ]]; then
504 PREFIX_ARG=$OLD_PREFIX
505 fi
506
507 if [[ -n "$OLD_MAKE" ]]; then
508 MAKE=$OLD_MAKE
509 fi
510
511 if [[ -n "$OLD_TESTS_ENVIRONMENT" ]]; then
512 TESTS_ENVIRONMENT=$OLD_TESTS_ENVIRONMENT
513 fi
514
515 OLD_CONFIGURE=
516 OLD_CONFIGURE_ARG=
517 OLD_PREFIX=
518 OLD_MAKE=
519 OLD_TESTS_ENVIRONMENT=
520
521 export -n CC CXX
522 }
523
524 function safe_pushd ()
525 {
526 pushd $1 &> /dev/null ;
527
528 if [ -n "$BUILD_DIR" ]; then
529 if $VERBOSE; then
530 echo "BUILD_DIR=$BUILD_DIR"
531 fi
532 fi
533 }
534
535 function safe_popd ()
536 {
537 local directory_to_delete=`pwd`
538 popd &> /dev/null ;
539 if [ $? -eq 0 ]; then
540 if [[ "$top_srcdir" == "$directory_to_delete" ]]; then
541 die "We almost deleted top_srcdir($top_srcdir), programmer error"
542 fi
543
544 rm -r -f "$directory_to_delete"
545 fi
546 }
547
548 function make_valgrind ()
549 {
550 # If the env VALGRIND_COMMAND is set then we assume it is valid
551 local valgrind_was_set=false
552 if [[ -z "$VALGRIND_COMMAND" ]]; then
553 setup_valgrind_command
554 if [[ -n "$VALGRIND_COMMAND" ]]; then
555 valgrind_was_set=true
556 fi
557 else
558 valgrind_was_set=true
559 fi
560
561 # If valgrind_was_set is set to no we bail
562 if ! $valgrind_was_set; then
563 echo 'valgrind was not present'
564 return 1
565 fi
566
567 save_BUILD
568
569 valgrind_run=true
570
571 # If we are required to run configure, do so now
572 run_configure
573
574 # If we don't have a configure, then most likely we will be missing libtool
575 assert_file 'configure'
576 if [[ -f 'libtool' ]]; then
577 TESTS_ENVIRONMENT="./libtool --mode=execute $VALGRIND_COMMAND"
578 else
579 TESTS_ENVIRONMENT="$VALGRIND_COMMAND"
580 fi
581
582 make_target 'check'
583 ret=$?
584
585 # If we aren't going to error, we will clean up our environment
586 if [ "$ret" -eq 0 ]; then
587 make 'distclean'
588 fi
589
590 valgrind_run=false
591
592 restore_BUILD
593
594 if [ "$ret" -ne 0 ]; then
595 return 1
596 fi
597 }
598
599 function make_install_system ()
600 {
601 local INSTALL_LOCATION=$(mktemp -d /tmp/XXXXXXXXXX)
602
603 save_BUILD
604 PREFIX_ARG="--prefix=$INSTALL_LOCATION"
605
606 if [ ! -d $INSTALL_LOCATION ] ; then
607 die "ASSERT temp directory not found '$INSTALL_LOCATION'"
608 fi
609
610 run_configure #install_buid_dir
611
612 make_target 'install'
613
614 make_target 'installcheck'
615
616 make_target 'uninstall'
617
618 rm -r -f $INSTALL_LOCATION
619 make 'distclean'
620
621 if [ -f 'Makefile' ]; then
622 die "ASSERT Makefile should not exist"
623 fi
624
625 restore_BUILD
626 safe_popd
627 }
628
629 function make_darwin_malloc ()
630 {
631 run_configure_if_required
632
633 old_MallocGuardEdges=$MallocGuardEdges
634 MallocGuardEdges=1
635 old_MallocErrorAbort=$MallocErrorAbort
636 MallocErrorAbort=1
637 old_MallocScribble=$MallocScribble
638 MallocScribble=1
639
640 make_check
641
642 MallocGuardEdges=$old_MallocGuardEdges
643 MallocErrorAbort=$old_MallocErrorAbort
644 MallocScribble=$old_MallocScribble
645 }
646
647 # This will reset our environment, and make sure built files are available.
648 function make_for_snapshot ()
649 {
650 # Lets make sure we have a clean environment
651 assert_no_file 'Makefile'
652 assert_no_file 'configure'
653 assert_no_directory 'autom4te.cache'
654
655 run_configure
656 make_target 'dist'
657 make_target 'distclean'
658
659 # We should have a configure, but no Makefile at the end of this exercise
660 assert_no_file 'Makefile'
661 assert_exec_file 'configure'
662 }
663
664 function check_mingw ()
665 {
666 command_exists 'mingw64-configure'
667 ret=$?
668 if [ "$ret" -ne 0 ]; then
669 return 1
670 fi
671
672 command_exists 'mingw64-make'
673 ret=$?
674 if [ "$ret" -ne 0 ]; then
675 return 1
676 fi
677
678 return 0
679 }
680
681 function check_clang ()
682 {
683 command_exists 'clang'
684 ret=$?
685 if [ "$ret" -ne 0 ]; then
686 return 1
687 fi
688
689 return 0
690 }
691
692 function check_clang_analyzer ()
693 {
694 command_exists 'scan-build'
695 ret=$?
696 if [ "$ret" -ne 0 ]; then
697 return 1
698 fi
699
700 return 0
701 }
702
703 function make_skeleton ()
704 {
705 run_configure
706 ret=$?
707
708 if [ $ret -eq 0 ]; then
709 assert_file 'Makefile'
710
711 make_target 'all' 'warn'
712 ret=$?
713 if [ $ret -ne 0 ]; then
714 warn "$MAKE failed"
715 else
716 if [[ -n "$DISPLAY" ]]; then
717 if command_exists 'wine'; then
718 TESTS_ENVIRONMENT='wine'
719 fi
720 fi
721
722 if [[ -n "$TESTS_ENVIRONMENT" ]]; then
723 make_target 'check' 'warn' || warn "$MAKE check failed"
724 ret=$?
725 fi
726 fi
727
728 if $jenkins_build_environment; then
729 make_target 'clean' 'warn'
730 fi
731 fi
732
733 return $ret
734 }
735
736 function make_for_mingw ()
737 {
738 if ! check_mingw; then
739 return 1
740 fi
741
742 # Make sure it is clean
743 if [ -f Makefile -o -f configure ]; then
744 make_maintainer_clean
745 fi
746
747 run_autoreconf
748
749 save_BUILD
750
751 CONFIGURE='mingw64-configure'
752 MAKE='mingw64-make'
753 CONFIGURE_ARGS='--enable-static --disable-shared'
754
755 make_skeleton
756 ret=$?
757
758 restore_BUILD
759
760 return $ret
761 }
762
763 function make_for_clang ()
764 {
765 if ! check_clang; then
766 return 1
767 fi
768
769 # Make sure it is clean
770 if [ -f Makefile -o -f configure ]; then
771 make_maintainer_clean
772 fi
773
774 run_autoreconf
775
776 save_BUILD
777
778 CC=clang CXX=clang++
779 export CC CXX
780
781 make_skeleton
782 ret=$?
783
784 make_target 'check'
785
786 restore_BUILD
787
788 return $ret
789 }
790
791 function make_for_clang_analyzer ()
792 {
793 if ! check_clang; then
794 return 1
795 fi
796
797 if ! check_clang_analyzer; then
798 die 'clang-analyzer was not found'
799 fi
800
801 # Make sure it is clean
802 if [ -f Makefile -o -f configure ]; then
803 make_maintainer_clean
804 fi
805
806 run_autoreconf
807
808 save_BUILD
809
810 CC=clang CXX=clang++
811 export CC CXX
812 CONFIGURE_ARGS='--enable-debug'
813
814 make_skeleton
815 ret=$?
816
817 make_target 'clean' 'warn'
818
819 scan-build -o clang-html make -j4 -k
820
821 restore_BUILD
822
823 return $ret
824 }
825
826 # If we are locally testing, we should make sure the environment is setup correctly
827 function check_for_jenkins ()
828 {
829 if ! $jenkins_build_environment; then
830 echo "Not inside of jenkins, simulating environment"
831
832 if [ -f 'configure' ]; then
833 make_maintainer_clean
834 fi
835
836 if $BOOTSTRAP_SNAPSHOT; then
837 make_for_snapshot
838 fi
839 fi
840 }
841
842 function make_universe ()
843 {
844 make_for_snapshot
845 make_valgrind
846 make_gdb
847 make_rpm
848 make_for_clang
849 make_for_clang_analyzer
850
851 if [ check_mingw -eq 0 ]; then
852 make_for_mingw
853 fi
854
855 make_distcheck
856 make_install_system
857 }
858
859 function make_for_continuus_integration ()
860 {
861 # Setup the environment if we are local
862 check_for_jenkins
863
864 # No matter then evironment, we should not have a Makefile at this point
865 assert_no_file 'Makefile'
866
867 # Platforms which require bootstrap should have some setup done before we hit this stage.
868 # If we are building locally, skip this step, unless we are just testing locally.
869 if $BOOTSTRAP_SNAPSHOT; then
870 if $BOOTSTRAP_SNAPSHOT; then
871 assert_file 'configure'
872 fi
873
874 if [ -n "$BOOTSTRAP_SNAPSHOT_CHECK" ]; then
875 assert_file "$BOOTSTRAP_SNAPSHOT_CHECK" 'snapshot check failed'
876 fi
877 else
878 # If we didn't require a snapshot, then we should not have a configure
879 assert_no_file 'configure'
880
881 run_autoreconf
882 fi
883
884 assert_no_file 'Makefile' 'Programmer error, Makefile existed where build state should have been clean'
885
886 case $HOST_OS in
887 *-fedora-*)
888 run_configure
889
890 assert_exec_file 'configure'
891 assert_file 'Makefile'
892
893 # make rpm includes "make distcheck"
894 if [[ -f rpm.am ]]; then
895 make_target 'all'
896 make_rpm
897 elif [[ -d rpm ]]; then
898 make_target 'all'
899 make_rpm
900 else
901 make_distcheck
902 fi
903 ;;
904 *-precise-*)
905 run_configure
906
907 assert_exec_file 'configure'
908 assert_file 'Makefile'
909
910 make_distcheck
911 ;;
912 *-quantal-*)
913 run_configure
914
915 assert_exec_file 'configure'
916 assert_file 'Makefile'
917
918 make_distcheck
919 ;;
920 *-raring-*)
921 run_configure
922
923 assert_exec_file 'configure'
924 assert_file 'Makefile'
925
926 make_distcheck
927 ;;
928 *)
929 make_jenkins_default
930 ;;
931 esac
932
933 make_maintainer_clean
934
935 safe_popd
936 }
937
938 # The point to this test is to test bootstrap.sh itself
939 function self_test ()
940 {
941 # We start off with a clean env
942 make_maintainer_clean
943
944 eval "./bootstrap.sh jenkins" || die "failed 'jenkins'"
945 eval "./bootstrap.sh all" || die "failed 'all'"
946 eval "./bootstrap.sh gdb" || die "failed 'gdb'"
947 eval "./bootstrap.sh maintainer-clean" || die "failed 'maintainer-clean'"
948 }
949
950 function make_install_html ()
951 {
952 run_configure_if_required
953 assert_file 'configure'
954
955 make_target 'install-html'
956 }
957
958 function make_gdb ()
959 {
960 save_BUILD
961
962 if command_exists 'gdb'; then
963 run_configure_if_required
964
965 # Set ENV GDB_COMMAND
966 if [[ -z "$GDB_COMMAND" ]]; then
967 setup_gdb_command
968 fi
969
970 # If we don't have a configure, then most likely we will be missing libtool
971 assert_file 'configure'
972 if [[ -f 'libtool' ]]; then
973 TESTS_ENVIRONMENT="./libtool --mode=execute $GDB_COMMAND"
974 else
975 TESTS_ENVIRONMENT="$GDB_COMMAND"
976 fi
977
978 make_target 'check'
979
980 if [ -f 'gdb.txt' ]; then
981 rm 'gdb.txt'
982 fi
983
984 if [ -f '.gdb_history' ]; then
985 rm '.gdb_history'
986 fi
987
988 if $jenkins_build_environment; then
989 make_target 'clean'
990 fi
991 else
992 echo 'gdb was not present'
993 return 1
994 fi
995
996 restore_BUILD
997 }
998
999 # $1 target to compile
1000 # $2 to die, or not to die, based on contents
1001 function make_target ()
1002 {
1003 if [ -z "$1" ]; then
1004 die "Programmer error, no target provided for make"
1005 fi
1006
1007 if [ ! -f 'Makefile' ]; then
1008 die "Programmer error, make was called before configure"
1009 run_configure
1010 fi
1011
1012 if [ -n "$TESTS_ENVIRONMENT" ]; then
1013 if $VERBOSE; then
1014 echo "TESTS_ENVIRONMENT=$TESTS_ENVIRONMENT"
1015 fi
1016 fi
1017
1018 if [ -z "$MAKE" ]; then
1019 die "MAKE was not set"
1020 fi
1021
1022 # $2 represents error or warn
1023 run $MAKE $1
1024 ret=$?
1025
1026 if [ $ret -ne 0 ]; then
1027 if [ -n "$2" ]; then
1028 warn "Failed to execute $MAKE $1: $ret"
1029 else
1030 die "Failed to execute $MAKE $1: $ret"
1031 fi
1032 fi
1033
1034 return $ret
1035 }
1036
1037 function make_distcheck ()
1038 {
1039 make_target 'distcheck'
1040 }
1041
1042 function make_rpm ()
1043 {
1044 if command_exists 'rpmbuild'; then
1045 if [ -f 'rpm.am' -o -d 'rpm' ]; then
1046 run_configure_if_required
1047 make_target 'rpm'
1048
1049 if $jenkins_build_environment; then
1050 make_target 'clean'
1051 fi
1052
1053 fi
1054 fi
1055 }
1056
1057 function make_maintainer_clean ()
1058 {
1059 run_configure_if_required
1060 make_target 'maintainer-clean' 'no_error'
1061
1062 # Lets make sure we really cleaned up the environment
1063 assert_no_file 'Makefile'
1064 assert_no_file 'configure'
1065 assert_no_directory 'autom4te.cache'
1066 }
1067
1068 function make_check ()
1069 {
1070 make_target 'check'
1071 }
1072
1073 function make_jenkins_default ()
1074 {
1075 run_configure
1076 make_target 'all'
1077 }
1078
1079 function make_default ()
1080 {
1081 run_configure_if_required
1082 make_target 'all'
1083 }
1084
1085 function run_configure_if_required ()
1086 {
1087 run_autoreconf_if_required
1088
1089 if [ ! -f 'Makefile' ]; then
1090 run_configure
1091 fi
1092
1093 assert_file 'Makefile' 'configure did not produce a Makefile'
1094 }
1095
1096 function run_make_maintainer_clean_if_possible ()
1097 {
1098 if [ -f 'Makefile' ]; then
1099 make_maintainer_clean
1100 fi
1101 }
1102
1103 function run_autoreconf_if_required ()
1104 {
1105 if [ ! -x 'configure' ]; then
1106 run_autoreconf
1107 fi
1108
1109 assert_exec_file 'configure'
1110 bash -n configure
1111 }
1112
1113 function run_autoreconf ()
1114 {
1115 if [[ -z "$AUTORECONF" ]]; then
1116 die "Programmer error, tried to call run_autoreconf () but AUTORECONF was not set"
1117 fi
1118
1119 if test $use_libtool = 1; then
1120 assert $BOOTSTRAP_LIBTOOLIZE
1121 run $BOOTSTRAP_LIBTOOLIZE '--copy' '--install' '--force' || die "Cannot execute $BOOTSTRAP_LIBTOOLIZE"
1122 fi
1123
1124 run $AUTORECONF $AUTORECONF_ARGS || die "Cannot execute $AUTORECONF"
1125
1126 eval 'bash -n configure' || die "autoreconf generated a malformed configure"
1127 }
1128
1129 function run ()
1130 {
1131 if $VERBOSE; then
1132 echo "\`$@' $ARGS"
1133 fi
1134
1135 if [ -z "$1" ]; then
1136 return 127;
1137 fi
1138
1139 eval $@ $ARGS
1140 }
1141
1142 function parse_command_line_options ()
1143 {
1144 local SHORTOPTS=':apcmt:dvh'
1145
1146 nassert MAKE_TARGET
1147
1148 while getopts "$SHORTOPTS" opt; do
1149 case $opt in
1150 a) #--autoreconf
1151 AUTORECONF_OPTION=true
1152 MAKE_TARGET='autoreconf'
1153 ;;
1154 p) #--print-env
1155 PRINT_SETUP_OPTION=true
1156 ;;
1157 c) # --configure
1158 CONFIGURE_OPTION=true
1159 MAKE_TARGET='configure'
1160 ;;
1161 m) # maintainer-clean
1162 CLEAN_OPTION=true
1163 MAKE_TARGET='clean_op'
1164 ;;
1165 t) # target
1166 TARGET_OPTION=true
1167 TARGET_OPTION_ARG="$OPTARG"
1168 MAKE_TARGET="$OPTARG"
1169 ;;
1170 d) # debug
1171 DEBUG_OPTION=true
1172 enable_debug
1173 ;;
1174 h) # help
1175 echo "bootstrap.sh [options] optional_target ..."
1176 echo " -a # Just run autoreconf";
1177 echo " -p # Print ENV";
1178 echo " -c # Just run configure";
1179 echo " -m # Just run maintainer-clean";
1180 echo " -t # Make target";
1181 echo " -d # Enable debug";
1182 echo " -h # Show help";
1183 echo " -v # Be more verbose in output";
1184 exit
1185 ;;
1186 v) # verbose
1187 VERBOSE_OPTION=true
1188 VERBOSE=true
1189 ;;
1190 :)
1191 echo "Option -$OPTARG requires an argument." >&2
1192 exit 1
1193 ;;
1194 *)
1195 echo "$0: error - unrecognized option $1" 1>&2
1196 exit 1
1197 ;;
1198 esac
1199 done
1200
1201 shift $((OPTIND-1))
1202
1203 if [ -n "$1" ]; then
1204 MAKE_TARGET="$@"
1205 fi
1206 }
1207
1208 function determine_vcs ()
1209 {
1210 if [[ -d '.git' ]]; then
1211 VCS_CHECKOUT=git
1212 elif [[ -d '.bzr' ]]; then
1213 VCS_CHECKOUT=bzr
1214 elif [[ -d '.svn' ]]; then
1215 VCS_CHECKOUT=svn
1216 elif [[ -d '.hg' ]]; then
1217 VCS_CHECKOUT=hg
1218 else
1219 VCS_CHECKOUT=
1220 fi
1221
1222 if [[ -n "$VCS_CHECKOUT" ]]; then
1223 VERBOSE=true
1224 fi
1225 }
1226
1227 function require_libtoolise ()
1228 {
1229 use_libtool=0
1230 grep '^[ ]*A[CM]_PROG_LIBTOOL' configure.ac >/dev/null \
1231 && use_libtool=1
1232 grep '^[ ]*LT_INIT' configure.ac >/dev/null \
1233 && use_libtool=1
1234 }
1235
1236 function autoreconf_setup ()
1237 {
1238 # Set ENV MAKE in order to override "make"
1239 if [[ -z "$MAKE" ]]; then
1240 if command_exists 'gmake'; then
1241 MAKE=`type -p gmake`
1242 else
1243 if command_exists 'make'; then
1244 MAKE=`type -p make`
1245 fi
1246 fi
1247
1248 if [ "$VCS_CHECKOUT" ]; then
1249 if $DEBUG; then
1250 MAKE="$MAKE --warn-undefined-variables"
1251 fi
1252 fi
1253
1254 if $DEBUG; then
1255 MAKE="$MAKE -d"
1256 fi
1257 fi
1258
1259 if [[ -z "$GNU_BUILD_FLAGS" ]]; then
1260 GNU_BUILD_FLAGS="--install --force"
1261 fi
1262
1263 if $VERBOSE; then
1264 GNU_BUILD_FLAGS="$GNU_BUILD_FLAGS --verbose"
1265 fi
1266
1267 if [ -z "$ACLOCAL_PATH" ]; then
1268 ACLOCAL_PATH="/usr/local/share/aclocal $ACLOCAL_PATH"
1269 fi
1270
1271 if [[ -z "$WARNINGS" ]]; then
1272 if [[ -n "$VCS_CHECKOUT" ]]; then
1273 WARNINGS="all,error"
1274 else
1275 WARNINGS="all"
1276 fi
1277 fi
1278
1279 if test $use_libtool = 1; then
1280 if [[ -n "$LIBTOOLIZE" ]]; then
1281 BOOTSTRAP_LIBTOOLIZE=`type -p $LIBTOOLIZE`
1282
1283 if [[ -z "$BOOTSTRAP_LIBTOOLIZE" ]]; then
1284 echo "Couldn't find user supplied libtoolize, it is required"
1285 return 1
1286 fi
1287 else
1288 # If we are using OSX, we first check to see glibtoolize is available
1289 if [[ "$VENDOR_DISTRIBUTION" == "darwin" ]]; then
1290 BOOTSTRAP_LIBTOOLIZE=`type -p glibtoolize`
1291
1292 if [[ -z "$BOOTSTRAP_LIBTOOLIZE" ]]; then
1293 echo "Couldn't find glibtoolize, it is required on OSX"
1294 return 1
1295 fi
1296 else
1297 BOOTSTRAP_LIBTOOLIZE=`type -p libtoolize`
1298
1299 if [[ -z "$BOOTSTRAP_LIBTOOLIZE" ]]; then
1300 echo "Couldn't find libtoolize, it is required"
1301 return 1
1302 fi
1303 fi
1304 fi
1305
1306 if $VERBOSE; then
1307 LIBTOOLIZE_OPTIONS="--verbose $BOOTSTRAP_LIBTOOLIZE_OPTIONS"
1308 fi
1309
1310 if $DEBUG; then
1311 LIBTOOLIZE_OPTIONS="--debug $BOOTSTRAP_LIBTOOLIZE_OPTIONS"
1312 fi
1313
1314 # Here we set LIBTOOLIZE to true since we are going to invoke it via BOOTSTRAP_LIBTOOLIZE
1315 LIBTOOLIZE=true
1316 fi
1317
1318 # Test the ENV AUTOMAKE if it exists
1319 if [[ -n "$AUTOMAKE" ]]; then
1320 run $AUTOMAKE '--help' &> /dev/null || die "Failed to run AUTOMAKE:$AUTOMAKE"
1321 fi
1322
1323 # Test the ENV AUTOCONF if it exists
1324 if [[ -n "$AUTOCONF" ]]; then
1325 run $AUTOCONF '--help' &> /dev/null || die "Failed to run AUTOCONF:$AUTOCONF"
1326 fi
1327
1328 # Test the ENV AUTOHEADER if it exists
1329 if [[ -n "$AUTOHEADER" ]]; then
1330 run $AUTOHEADER '--help' &> /dev/null || die "Failed to run AUTOHEADER:$AUTOHEADER"
1331 fi
1332
1333 # Test the ENV AUTOM4TE if it exists
1334 if [[ -n "$AUTOM4TE" ]]; then
1335 run $AUTOM4TE '--help' &> /dev/null || die "Failed to run AUTOM4TE:$AUTOM4TE"
1336 fi
1337
1338 # Test the ENV AUTOHEADER if it exists, if not we add one and add --install
1339 if [[ -z "$ACLOCAL" ]]; then
1340 ACLOCAL="aclocal --install"
1341 fi
1342 run $ACLOCAL '--help' &> /dev/null || die "Failed to run ACLOCAL:$ACLOCAL"
1343
1344 if [[ -z "$AUTORECONF" ]]; then
1345 AUTORECONF=`type -p autoreconf`
1346
1347 if [[ -z "$AUTORECONF" ]]; then
1348 die "Couldn't find autoreconf"
1349 fi
1350
1351 if [[ -n "$GNU_BUILD_FLAGS" ]]; then
1352 AUTORECONF_ARGS="$GNU_BUILD_FLAGS"
1353 fi
1354 fi
1355
1356 run $AUTORECONF '--help' &> /dev/null || die "Failed to run AUTORECONF:$AUTORECONF"
1357 }
1358
1359 function print_setup ()
1360 {
1361 saved_debug_status=$DEBUG
1362 if $DEBUG; then
1363 disable_debug
1364 fi
1365
1366 echo '----------------------------------------------'
1367 echo 'BOOTSTRAP ENV'
1368 echo "AUTORECONF=$AUTORECONF"
1369 echo "HOST_OS=$HOST_OS"
1370 echo "VENDOR=$VENDOR"
1371 echo "VENDOR_DISTRIBUTION=$VENDOR_DISTRIBUTION"
1372 echo "VENDOR_RELEASE=$VENDOR_RELEASE"
1373
1374 echo "getopt()"
1375 if $AUTORECONF_OPTION; then
1376 echo "--autoreconf"
1377 fi
1378
1379 if $CLEAN_OPTION; then
1380 echo "--clean"
1381 fi
1382
1383 if $CONFIGURE_OPTION; then
1384 echo "--configure"
1385 fi
1386
1387 if $DEBUG_OPTION; then
1388 echo "--debug"
1389 fi
1390
1391 if $PRINT_SETUP_OPTION; then
1392 echo "--print-env"
1393 fi
1394
1395 if $TARGET_OPTION; then
1396 echo "--target=$TARGET_OPTION_ARG"
1397 fi
1398
1399 if $VERBOSE_OPTION; then
1400 echo "--verbose"
1401 fi
1402
1403 if [[ -n "$MAKE" ]]; then
1404 echo "MAKE=$MAKE"
1405 fi
1406
1407 if [[ -n "$MAKE_TARGET" ]]; then
1408 echo "MAKE_TARGET=$MAKE_TARGET"
1409 fi
1410
1411 if [[ -n "$PREFIX" ]]; then
1412 echo "PREFIX=$PREFIX"
1413 fi
1414
1415 if [[ -n "$TESTS_ENVIRONMENT" ]]; then
1416 echo "TESTS_ENVIRONMENT=$TESTS_ENVIRONMENT"
1417 fi
1418
1419 if [[ -n "$VCS_CHECKOUT" ]]; then
1420 echo "VCS_CHECKOUT=$VCS_CHECKOUT"
1421 fi
1422
1423 if $VERBOSE; then
1424 echo "VERBOSE=true"
1425 fi
1426
1427 if $DEBUG; then
1428 echo "DEBUG=true"
1429 fi
1430
1431 if [[ -n "$WARNINGS" ]]; then
1432 echo "WARNINGS=$WARNINGS"
1433 fi
1434 echo '----------------------------------------------'
1435
1436 if $saved_debug_status; then
1437 enable_debug
1438 fi
1439 }
1440
1441 function make_clean_option ()
1442 {
1443 run_configure_if_required
1444
1445 make_maintainer_clean
1446
1447 if [[ "$VCS_CHECKOUT" == 'git' ]]; then
1448 run "$VCS_CHECKOUT" status --ignored
1449 elif [[ -n "$VCS_CHECKOUT" ]]; then
1450 run "$VCS_CHECKOUT" status
1451 fi
1452 }
1453
1454 function make_for_autoreconf ()
1455 {
1456 if [ -f 'Makefile' ]; then
1457 make_maintainer_clean
1458 fi
1459
1460 run_autoreconf
1461
1462 assert_no_file 'Makefile'
1463 }
1464
1465 function check_make_target()
1466 {
1467 case $1 in
1468 'self')
1469 ;;
1470 'rpm')
1471 ;;
1472 'gdb')
1473 ;;
1474 'clean_op')
1475 ;;
1476 'autoreconf')
1477 ;;
1478 'install-system')
1479 ;;
1480 'configure')
1481 ;;
1482 'distcheck')
1483 ;;
1484 'check')
1485 ;;
1486 'snapshot')
1487 ;;
1488 'mingw')
1489 ;;
1490 'universe')
1491 ;;
1492 'valgrind')
1493 ;;
1494 'jenkins')
1495 ;;
1496 'distclean')
1497 ;;
1498 'maintainer-clean')
1499 ;;
1500 'install')
1501 ;;
1502 'all')
1503 ;;
1504 'make_default')
1505 ;;
1506 'clang')
1507 ;;
1508 'clang-analyzer')
1509 ;;
1510 test-*)
1511 ;;
1512 valgrind-*)
1513 ;;
1514 gdb-*)
1515 ;;
1516 'dist')
1517 ;;
1518 *)
1519 echo "Matched default"
1520 return 1
1521 ;;
1522 esac
1523
1524 return 0
1525 }
1526
1527 function bootstrap ()
1528 {
1529 determine_target_platform
1530
1531 determine_vcs
1532
1533 # Set up whatever we need to do to use autoreconf later
1534 require_libtoolise
1535 if ! autoreconf_setup; then
1536 return 1
1537 fi
1538
1539 if [ -z "$MAKE_TARGET" ]; then
1540 MAKE_TARGET="make_default"
1541 fi
1542
1543 if $PRINT_SETUP_OPTION -o $DEBUG; then
1544 echo
1545 print_setup
1546 echo
1547
1548 # Exit if all we were looking for were the currently used options
1549 if $PRINT_SETUP_OPTION; then
1550 exit
1551 fi
1552 fi
1553
1554 # Use OLD_TESTS_ENVIRONMENT for tracking the state of the variable
1555 local OLD_TESTS_ENVIRONMENT=
1556
1557 # Set ENV PREFIX in order to set --prefix for ./configure
1558 if [[ -n "$PREFIX" ]]; then
1559 PREFIX_ARG="--prefix=$PREFIX"
1560 fi
1561
1562 # We should always have a target by this point
1563 assert MAKE_TARGET
1564
1565 local MAKE_TARGET_ARRAY=($MAKE_TARGET)
1566
1567 for target in "${MAKE_TARGET_ARRAY[@]}"
1568 do
1569 # If we are running inside of Jenkins, we want to only run some of the possible tests
1570 if $jenkins_build_environment; then
1571 check_make_target $target
1572 ret=$?
1573 if [ $ret -ne 0 ]; then
1574 die "Unknown MAKE_TARGET option: $target"
1575 fi
1576 fi
1577
1578 local snapshot_run=false
1579 local valgrind_run=false
1580
1581 case $target in
1582 'self')
1583 self_test
1584 ;;
1585 'gdb')
1586 make_gdb
1587 ;;
1588 'install-html')
1589 make_install_html
1590 ;;
1591 'clean_op')
1592 make_clean_option
1593 ;;
1594 'autoreconf')
1595 make_for_autoreconf
1596 ;;
1597 'install-system')
1598 make_install_system
1599 ;;
1600 'configure')
1601 run_configure
1602 ;;
1603 'make_default')
1604 make_default
1605 ;;
1606 'clang')
1607 if ! check_clang; then
1608 die "clang was not found"
1609 fi
1610
1611 if ! make_for_clang; then
1612 die "Failed to build clang: $?"
1613 fi
1614 ;;
1615 'clang-analyzer')
1616 if ! check_clang_analyzer; then
1617 die "clang-analyzer was not found"
1618 fi
1619 if ! check_clang; then
1620 die "clang was not found"
1621 fi
1622
1623 if ! make_for_clang_analyzer; then
1624 die "Failed to build clang-analyzer: $?"
1625 fi
1626 ;;
1627 'mingw')
1628 if ! check_mingw; then
1629 die "mingw was not found"
1630 fi
1631
1632 if ! make_for_mingw; then
1633 die "Failed to build mingw: $?"
1634 fi
1635 ;;
1636 'snapshot')
1637 make_for_snapshot
1638 snapshot_run=true
1639 ;;
1640 'rpm')
1641 make_rpm
1642 ;;
1643 'darwin_malloc')
1644 make_darwin_malloc
1645 ;;
1646 'valgrind')
1647 make_maintainer_clean
1648 make_valgrind
1649 ;;
1650 'universe')
1651 make_universe
1652 ;;
1653 'jenkins')
1654 make_for_continuus_integration
1655 ;;
1656 *)
1657 run_configure_if_required
1658 make_target "$target"
1659 ;;
1660 esac
1661
1662 if $jenkins_build_environment; then
1663 if ! $snapshot_run; then
1664 run_make_maintainer_clean_if_possible
1665 fi
1666 fi
1667
1668 done
1669 }
1670
1671 function main ()
1672 {
1673 # Variables we export
1674 declare -x VCS_CHECKOUT=
1675
1676 # Variables we control globally
1677 local MAKE_TARGET=
1678 local CONFIGURE=
1679
1680 # Options for getopt
1681 local AUTORECONF_OPTION=false
1682 local CLEAN_OPTION=false
1683 local CONFIGURE_OPTION=false
1684 local DEBUG_OPTION=false
1685 local PRINT_SETUP_OPTION=false
1686 local TARGET_OPTION=false
1687 local TARGET_OPTION_ARG=
1688 local VERBOSE_OPTION=false
1689
1690 local OLD_CONFIGURE=
1691 local OLD_CONFIGURE_ARG=
1692 local OLD_PREFIX=
1693 local OLD_MAKE=
1694 local OLD_TESTS_ENVIRONMENT=
1695
1696 # If we call autoreconf on the platform or not
1697 local AUTORECONF_REBUILD_HOST=false
1698 local AUTORECONF_REBUILD=false
1699
1700 local -r top_srcdir=`pwd`
1701
1702 # Default configure
1703 if [ -z "$CONFIGURE" ]; then
1704 CONFIGURE="$top_srcdir/configure"
1705 fi
1706
1707
1708 # Variables for determine_target_platform () and rebuild_host_os ()
1709 # UNAME_MACHINE_ARCH= uname -m
1710 # VENDOR= apple, redhat, centos, canonical
1711 # VENDOR_RELEASE=
1712 # RHEL{rhel,Tikanga,Santiago}
1713 # Ubuntu{ubuntu,Lucid,Maverick,Natty,Oneiric,Precise,Quantal}
1714 # Fedora{fedora,Verne,Beefy}
1715 # OSX{osx,lion,snow,mountain}
1716 # VENDOR_DISTRIBUTION= darwin,fedora,rhel,ubuntu
1717 # UNAME_KERNEL= Linux, Darwin,...
1718 # UNAME_KERNEL_RELEASE= Linux, Darwin,...
1719 local UNAME_MACHINE_ARCH=unknown
1720 local VENDOR=unknown
1721 local VENDOR_RELEASE=unknown
1722 local VENDOR_DISTRIBUTION=unknown
1723 local UNAME_KERNEL=unknown
1724 local UNAME_KERNEL_RELEASE=unknown
1725 local HOST_OS=
1726
1727 rebuild_host_os no_output
1728
1729 parse_command_line_options $@
1730
1731 # If we are running under Jenkins we predetermine what tests we will run against
1732 # This MAKE_TARGET can be overridden by parse_command_line_options based MAKE_TARGET changes.
1733 # We don't want Jenkins overriding other variables, so we NULL them.
1734 if [ -z "$MAKE_TARGET" ]; then
1735 if $jenkins_build_environment; then
1736 if [[ -n "$label" ]]; then
1737 check_make_target $label
1738 if [ $? -eq 0 ]; then
1739 MAKE_TARGET="$label"
1740 fi
1741 fi
1742
1743 if [ -z "$MAKE_TARGET" ]; then
1744 MAKE_TARGET='jenkins'
1745 fi
1746 fi
1747 fi
1748
1749 bootstrap
1750
1751 jobs -l
1752 wait
1753
1754 exit 0
1755 }
1756
1757 function set_branch ()
1758 {
1759 if [ -z "$BRANCH" ]; then
1760 if [ -z "$CI_PROJECT_TEAM" ]; then
1761 die "Variable CI_PROJECT_TEAM has not been set"
1762 fi
1763 if [ -z "$PROJECT" ]; then
1764 die "Variable PROJECT has not been set"
1765 fi
1766 if [ -z "$BUILD_TAG" ]; then
1767 die "Variable BUILD_TAG has not been set"
1768 fi
1769
1770 BRANCH="lp:~$CI_PROJECT_TEAM/$PROJECT/$BUILD_TAG"
1771 export BRANCH
1772 fi
1773
1774 if [ -z "$BRANCH" ]; then
1775 die "Missing values required to build BRANCH variable."
1776 fi
1777 }
1778
1779 function merge ()
1780 {
1781 if [ -z "$VCS_CHECKOUT" ]; then
1782 die "Merges require VCS_CHECKOUT."
1783 fi
1784
1785 set_branch
1786
1787 if [[ "$VCS_CHECKOUT" == 'bzr' ]]; then
1788 if test -n "$BRANCH_TO_MERGE"; then
1789 bzr merge $BRANCH_TO_MERGE
1790 bzr commit --message="Merge $BRANCH_TO_MERGE Build: $BUILD_TAG" --unchanged
1791 fi
1792
1793 bzr push "$BRANCH"
1794 elif [[ -n "$VCS_CHECKOUT" ]]; then
1795 die "Merge attempt occured, current VCS setup does not support this"
1796 fi
1797 }
1798
1799 function enable_debug ()
1800 {
1801 if ! $DEBUG; then
1802 local caller_loc=`caller`
1803 if [ -n $1 ]; then
1804 echo "$caller_loc Enabling debug: $1"
1805 else
1806 echo "$caller_loc Enabling debug"
1807 fi
1808 set -x
1809 DEBUG=true
1810 fi
1811 }
1812
1813 function usage ()
1814 {
1815 cat << EOF
1816 Usage: $program_name [OPTION]..
1817
1818 Bootstrap this package from the checked-out sources, and optionally walk through CI run.
1819
1820 Options:
1821
1822 EOF
1823 }
1824
1825 function disable_debug ()
1826 {
1827 set +x
1828 DEBUG=true
1829 }
1830
1831 # Script begins here
1832
1833 program_name=$0
1834
1835 env_debug_enabled=false
1836 if [[ -n "$JENKINS_HOME" ]]; then
1837 declare -r jenkins_build_environment=true
1838 else
1839 declare -r jenkins_build_environment=false
1840 fi
1841
1842 export ACLOCAL
1843 export AUTOCONF
1844 export AUTOHEADER
1845 export AUTOM4TE
1846 export AUTOMAKE
1847 export AUTORECONF
1848 export CONFIGURE_ARG
1849 export DEBUG
1850 export GNU_BUILD_FLAGS
1851 export LIBTOOLIZE
1852 export LIBTOOLIZE_OPTIONS
1853 export MAKE
1854 export PREFIX_ARG
1855 export TESTS_ENVIRONMENT
1856 export VERBOSE
1857 export WARNINGS
1858
1859 case $OSTYPE in
1860 darwin*)
1861 export MallocGuardEdges
1862 export MallocErrorAbort
1863 export MallocScribble
1864 ;;
1865 esac
1866
1867 # We check for DEBUG twice, once before we source the config file, and once afterward
1868 env_debug_enabled=false
1869 if [[ -n "$DEBUG" ]]; then
1870 env_debug_enabled=true
1871 enable_debug
1872 print_setup
1873 fi
1874
1875 # Variables which only can be set by .bootstrap
1876 BOOTSTRAP_SNAPSHOT=false
1877 BOOTSTRAP_SNAPSHOT_CHECK=
1878
1879 if [ -f '.bootstrap' ]; then
1880 source '.bootstrap'
1881 fi
1882
1883 if $env_debug_enabled; then
1884 enable_debug
1885 else
1886 if [[ -n "$DEBUG" ]]; then
1887 enable_debug "Enabling DEBUG from '.bootstrap'"
1888 print_setup
1889 fi
1890 fi
1891
1892 # We do this in order to protect the case where DEBUG
1893 if ! $env_debug_enabled; then
1894 DEBUG=false
1895 fi
1896
1897 main $@